function JobForemanSO::getError(%so, %client)
{
	return parent::getError(%so, %client);
}

function JobForemanSO::getLaborBonus(%so, %client)
{
	return 2;
}

function JobForemanSO::getSuccessMessage(%so)
{
	return "\c6Your strength and education has led you up the ladder to \c3Foreman\c6! Rookie laborers benefit just from your presence!";
}

function JobForemanSO::giveLaborBonus(%so)
{
	return 2;
}

if(!isObject(JobForemanSO))
{
	new ScriptObject(JobForemanSO)
	{
		class			= "JobSO";
		name			= "Foreman";
		id				= "1" @ "03" @ "04";
		
		cleanRecord	= false;
		cost			= 0;
		education	= 4;
		expMin		= 2500;
		expTier		= 2;
		expTree		= "Labor";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		outfit		= "OutfitForemanSO";
		tools			= "CRPG_Lumberjack_Item" TAB "CRPG_Pickaxe_Item";
	};
}

if(!isObject(OutfitForemanSO))
{
	new ScriptObject(OutfitForemanSO)
	{
		class = "OutfitSO";
		
		decal = "worm_engineer";
		outfit = 8;
		
		node[0] = "genderlarm";
		node[1] = "LHand";
		node[2] = "genderrarm";
		node[3] = "RHand";
		node[4] = "pants";
		node[5] = "LShoe";
		node[6] = "RShoe";
		node[7] = "epaulets";
		
		color[0] = "0.20 0.20 0.20 1.00";
		color[1] = "0.20 0.20 0.20 1.00";
		color[2] = "0.20 0.20 0.20 1.00";
		color[3] = "0.20 0.20 0.20 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		
		outfitMale		= 3;
		nodeMale[0]		= "gender";
		colorMale[0]	= "0.39 0.00 0.12 1.00";
		nodeMale[1]		= "copHat";
		colorMale[1]	= "0.20 0.20 0.20 1.00";
		nodeMale[2]		= "pack";
		colorMale[2]	= "0.20 0.20 0.20 1.00";
		
		outfitFem		= 3;
		nodeFem[0]		= "gender";
		colorFem[0]		= "0.91 0.50 0.59 1.00";
		nodeFem[1]		= "knitHat";
		colorFem[1]		= "0.20 0.20 0.20 1.00";
		nodeFem[2]		= "pack";
		colorFem[2]		= "0.90 0.50 0.59 1.00";
	};
}
