function JobGrocerSO::getSuccessMessage(%so)
{
	return "\c6The Food and Drug Administration has approved your food sales liscense. You are now a \c3Grocer\c6.";
}

if(!isObject(JobGrocerSO))
{
	new ScriptObject(JobGrocerSO)
	{
		class			= "JobSO";
		name			= "Grocer";
		id				= "1" @ "04" @ "02";
		
		cleanRecord	= false;
		cost			= 1000;
		education	= 1;
		expMin		= 0;
		expTier		= 0;
		expTree		= "Store";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		runFactory	= false;
		runMonopoly	= false;
		sellArms		= false;
		sellFood		= true;
		sellVehicle	= false;
		
		outfit		= "OutfitGrocerSO";
		tools			= "";
	};
}

if(!isObject(OutfitGrocerSO))
{
	new ScriptObject(OutfitGrocerSO)
	{
		class = "OutfitSO";
		
		decal = "worm_engineer";
		outfit = 8;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		
		color[0] = "1.00 1.00 1.00 1.00";
		color[1] = "1.00 1.00 1.00 1.00";
		color[2] = "1.00 1.00 1.00 1.00";
		color[3] = "skin";
		color[4] = "skin";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
	};
}