function JobLumberjackSO::getLaborBonus(%so, %client)
{
	%bonus = 0;
	
	if(isObject(%client.player))
	{
		initContainerRadiusSearch(%client.player.getPosition(), 16, $TypeMasks::PlayerObjectType);
		
		while(isObject(%col = containerSearchNext()))
		{
			%cp = %col.client.profile;
			
			if(isObject(%cp))
			{
				%cbonus = %cp.getJob().giveLaborBonus();
				
				if(%cbonus > %bonus)
				{
					%bonus = %cbonus;
				}
			}
		}
	}
	
	return %bonus;
}

function JobLumberjackSO::onEXP(%so, %profile, %exp)
{
	if(JobLaborerSO.isApplicable(%profile))
		JobLaborerSO.setJobFor(%profile);
}

if(!isObject(JobLumberjackSO))
{
	new ScriptObject(JobLumberjackSO)
	{
		class			= "JobSO";
		name			= "Lumberjack";
		id				= "1" @ "02" @ "01";
		
		cleanRecord	= false;
		cost			= 0;
		education	= 0;
		expMin		= 0;
		expTier		= 0;
		expTree		= "Labor";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		outfit		= "OutfitLumberjackSO";
		tools			= "CRPG_Lumberjack_Item";
	};
}

if(!isObject(OutfitLumberjackSO))
{
	new ScriptObject(OutfitLumberjackSO)
	{
		class = "OutfitSO";
		
		decal = "worm_engineer";
		outfit = 9;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "LHand";
		node[3] = "genderrarm";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "knitHat";
		
		color[0] = "0.39 0.00 0.12 1.00";
		color[1] = "0.39 0.00 0.12 1.00";
		color[2] = "skin";
		color[3] = "0.39 0.00 0.12 1.00";
		color[4] = "skin";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.20 0.20 0.20 1.00";
	};
}