function JobPolicemanSO::getArmor(%so)
{
	return 0.1;
}

function JobPolicemanSO::getSuccessMessage(%so, %profile)
{
	return "\c6Here's your badge, and here's your gun. You are now a \c3Police Officer\c6.";
}

function JobPolicemanSO::onKilled(%so, %client, %profile, %sourceClient, %sourceProfile, %sourceObject, %transform, %damageType)
{
	if(!%profile.getWantedLevel())
	{
		%sourceClient.commitCrime("Murdering an Officer", 250, false, true, false, true, 240000, %transform);
	}
}

function JobPolicemanSO::onTick(%so, %client)
{
	%profile = %client.profile;
	
	if(isObject(%profile))
	{
		%profile.workhours += CalendarSO.length;
		
		if(mFloor(CalendarSO.time / 24) > mFloor((CalendarSO.time - CalendarSO.length) / 24))
		{
			%pay = %so.paycheck;
			%pay *= %profile.workhours / 168;
			%pay = mFloor(%pay);
			
			%pay = SystemSO.deductFromTreasury(%pay); 
			if(%pay > 100)
			{
				%profile.exp[%so.expTree]++;
				
				%profile.workhours = 0;
				%interest = mClamp(mFloor(%profile.debt * 0.1), 0, mFloor(%pay / 2));
				
				if(%interest > 0)
				{
					%final -= %interest;
					
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck, but \c0$%2\c6 was automatically taken out due to your debt\'s interest.', %pay, %interest);
					%profile.bank += %final;
				}
				else
				{
					messageClient(%client, '', '\c6 - You recieved a \c3$%1\c6 paycheck.', %pay);
					%profile.bank += %pay;
				}
			}
		}
	}
}

if(!isObject(JobPolicemanSO))
{
	new ScriptObject(JobPolicemanSO)
	{
		class			= "JobSO";
		name			= "Policeman";
		id				= "1" @ "05" @ "01";
		
		cleanRecord	= true;
		cost			= 2500;
		education	= 1;
		expMin		= 0;
		expTier		= 0;
		expTree		= "Law";
		paycheck		= 750;
		payday		= 4;
		police		= true;
		
		outfit		= "OutfitPolicemanSO";
		tools			= "CRPG_Baton_Item" TAB "CRPG_HandcuffsU_Item" TAB "CRPG_Magnify_Item" TAB "CRPG_Handgun_Item";
	};
}

if(!isObject(OutfitPolicemanSO))
{
	new ScriptObject(OutfitPolicemanSO)
	{
		class = "OutfitSO";
		
		decal = "Mod-Police";
		outfit = 9;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "copHat";
		
		color[0] = "0.00 0.14 0.33 1.00";
		color[1] = "0.00 0.14 0.33 1.00";
		color[2] = "0.00 0.14 0.33 1.00";
		color[3] = "skin";
		color[4] = "skin";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.00 0.14 0.33 1.00";
	};
}
