if(!$CRPG_Temp::WeaponsMade)
{
	eval("AddDamageType(\"CRPGHandgun\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Handgun> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Handgun> %1', 0.25, 1);");
	eval("AddDamageType(\"CRPGHandgunHeadshot\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Handgun><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Handgun><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', 0.25, 1);");
}

// Sounds
datablock AudioProfile(CRPG_Handgun_Arm_Sound)
{
	filename		= $CRPG::Path::Sounds @ "handgun_cock.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Handgun_Fire_Sound)
{
	filename		= $CRPG::Path::Sounds @ "handgun_fire.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Handgun_Reload_Sound)
{
	filename		= $CRPG::Path::Sounds @ "handgun_reload.wav";
	description	= AudioClose3d;
	preload		= true;
};

datablock AudioProfile(CRPG_Handgun_Unload_Sound)
{
	filename		= $CRPG::Path::Sounds @ "handgun_unload.wav";
	description	= AudioClose3d;
	preload		= true;
};

// Particles and Emitters
// Most of this shit is by Bushido

// Ring
datablock ParticleData(CRPG_Handgun_Explosion_Star_Particle)
{
	dragCoefficient			= 8;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.2;
	constantAcceleration		= 0.0;
	lifetimeMS					= 20;
	lifetimeVarianceMS		= 0;
	textureName					= "base/data/particles/star1";
	spinSpeed					= 0.0;
	spinRandomMin				= 0.0;
	spinRandomMax				= 0.0;
	colors[0]					= "1 1 0.0 0.9";
	colors[1]					= "0.9 0.0 0.0 0.0";
	sizes[0]						= 1;
	sizes[1]						= 2;
	useInvAlpha					= false;
};

datablock ParticleEmitterData(CRPG_Handgun_Explosion_Star_Emitter)
{
	lifeTimeMS			= 50;
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0.0;
	ejectionOffset		= 0.0;
	thetaMin				= 89;
	thetaMax				= 90;
	phiReferenceVel	= 0;
	phiVariance			= 360;
	overrideAdvance	= false;
	particles			= "CRPG_Handgun_Explosion_Star_Particle";
};

// Ring 2
datablock ParticleData(CRPG_Handgun_Explosion_Dot_Particle)
{
	dragCoefficient			= 2;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.2;
	constantAcceleration		= 0.0;
	lifetimeMS					= 1240;
	lifetimeVarianceMS		= 1230;
	textureName					= "base/data/particles/dot";
	spinSpeed					= 0.0;
	spinRandomMin				= 0.0;
	spinRandomMax				= 0.0;
	colors[0]					= "1 1 0.0 0.9";
	colors[1]					= "1 1 1.0 0.0";
	sizes[0]						= 0.1;
	sizes[1]						= 0.2;
	useInvAlpha					= false;
};

datablock ParticleEmitterData(CRPG_Handgun_Explosion_Dot_Emitter)
{
	lifeTimeMS			= 100;
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 3;
	velocityVariance	= 3.0;
	ejectionOffset		= 1.0;
	thetaMin				= 0;
	thetaMax				= 180;
	phiReferenceVel	= 0;
	phiVariance			= 360;
	overrideAdvance	= false;
	particles			= "CRPG_Handgun_Explosion_Dot_Particle";
};

// Debris
datablock DebrisData(CRPG_Handgun_Debris)
{
	shapeFile			= $CRPG::Path::Shapes @ "Handgun_Eject.dts";
	lifetime				= 5.0;
	minSpinSpeed		= -400.0;
	maxSpinSpeed		= 200.0;
	elasticity			= 0.5;
	friction				= 0.2;
	numBounces			= 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce 	= false;
	fade					= true;
	gravModifier		= 1;
};

// Explosion
datablock ExplosionData(CRPG_Handgun_Explosion)
{
	soundProfile		= CRPG_Generic_Hit_Sound;
	
	lifeTimeMS			= 150;
	
	particleEmitter	= CRPG_Handgun_Explosion_Star_Emitter;
	particleDensity	= 5;
	particleRadius		= 0.2;
	
	emitter[0]			= CRPG_Handgun_Explosion_Star_Emitter;
	emitter[1]			= CRPG_Handgun_Explosion_Dot_Emitter;
	
	faceViewer			= true;
	explosionScale		= "1 1 1";
	
	shakeCamera			= false;
	camShakeFreq		= "10.0 11.0 10.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 10.0;
	
	lightStartRadius	= 1;
	lightEndRadius		= 0;
	lightStartColor	= "0.3 0.6 0.7";
	lightEndColor		= "0 0 0";

	impulseRadius		= 2;
	impulseForce		= 7500;
};

// Projectile
datablock ProjectileData(CRPG_Handgun_Projectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	
	directDamage				= 75;
	directDamageType		= $DamageType::CRPGHandgun;
	radiusDamageType		= $DamageType::CRPGHandgun;
	
	brickExplosionRadius	= 0;
	brickExplosionImpact	= true;
	brickExplosionForce		= 10;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;
	
	impactImpulse			= 1900;
	verticalImpulse		= 400;
	explosion					= CRPG_Handgun_Explosion;
	
	muzzleVelocity			= 200;
	velInheritFactor		= 1;
	
	armingDelay			= 00;
	lifetime						= 9000;
	fadeDelay				= 8500;
	bounceElasticity		= 0.5;
	bounceFriction			= 0.20;
	isBallistic					= false;
	gravityMod				= 0.1;
	
	hasLight					= false;
	lightRadius				= 3.0;
	lightColor					= "0 0 0.5";
};

// Item
datablock ItemData(CRPG_Handgun_Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Basic Item Properties
	shapeFile = $CRPG::Path::Shapes @ "Handgun_Item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "Handgun";
	iconName = $CRPG::Path::Images @ "itemIcons/Icon_Handgun";
	doColorShift = false;
	colorShiftColor = "0.4 0.2 0 1.000";
	
	image = CRPG_Handgun_Image;
	canDrop = true;
	isFirearm = true;
};

// Image
datablock ShapeBaseImageData(CRPG_Handgun_Image)
{
	// Raycast Properties
	raycastWeaponRange				= 128;
	raycastWeaponOptimalRange		= 32;
	raycastWeaponTargets				= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastWeaponPierceTargets		= 0;
	raycastDirectDamage				= 20;
	raycastDirectDamageType			= $DamageType::CRPGHandgun;
	raycastCritDirectDamageType	= $DamageType::CRPGHandgunHeadshot;
	raycastExplosionProjectile		= CRPG_Handgun_Projectile;
	raycastExplosionSound			= CRPG_Generic_Hit_Sound;
	raycastExplosionPlayerSound	= CRPG_Generic_Hit_Sound;
	raycastExplosionBrickSound		= CRPG_Generic_Hit_Sound;
	raycastExplosionCritSound		= CRPG_Generic_Hit_Sound;
	raycastSpreadAmt					= 0.0030;	
	raycastSpreadCount				= 1;
	raycastTracerProjectile			= 0;
	raycastFromMuzzle					= true;
	
	// CRPG Properties
	ammo			= "handgun";
	ammoMagSize	= 8;
	ammoUi		= "9x18 Makarov";
	backpack		= CRPG_Handgun_Back_Image;
	gunTier		= 1;
	kickBack		= 20;
	sensitive	= false;
	
	
	item = CRPG_Handgun_Item;
	
	// Basic Item properties
	shapeFile = $CRPG::Path::Shapes @ "Handgun.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile
	item					= CRPG_Handgun_Item;
	projectile			= hammerProjectile;
	projectileType		= Projectile;
	
	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = true;

	doColorShift = false;
	colorShiftColor = "0.4 0.2 0 1.000";
	
	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]									= "Activate";
	stateTimeoutValue[0]							= 0.1;
	stateTransitionOnTimeout[0]				= "PreAmmoCheck";
	stateSequence[0]								= "cock";
	stateSound[0]									= CRPG_Handgun_Arm_Sound;

	stateName[1]									= "Ready";
	stateTransitionOnTriggerDown[1]			= "Fire";
	stateTransitionOnNoAmmo[1]					= "AmmoCheck";
	stateAllowImageChange[1]					= true;

	stateName[2]									= "Fire";
	stateTransitionOnTimeout[2]				= "Smoke";
	stateSequence[2]								= "fire";
	stateTimeoutValue[2]							= 0.15;
	stateFire[2]									= true;
	stateAllowImageChange[2]					= false;
	stateScript[2]									= "onFire";
	stateWaitForTimeout[2]						= true;
	stateEmitter[2]								= CRPG_Flash_Emitter;
	stateEmitterTime[2]							= 0.05;
	stateEmitterNode[2]							= "muzzleNode";
	stateSound[2]									= CRPG_Handgun_Fire_Sound;
	
	stateName[3]									= "Smoke";
	stateEjectShell[3]							= true;
	stateEmitter[3]								= CRPG_Smoke_Emitter;
	stateEmitterTime[3]							= 0.033;
	stateEmitterNode[3]							= "muzzleNode";
	stateTransitionOnTriggerUp[3]				= "PreAmmoCheck";
	
	stateName[4]									= "PreReload";
	stateWaitForTimeout[4]						= true;
	stateTransitionOnTimeout[4]				= "Reload";
	stateTimeoutValue[4]							= 0.2;

	stateName[5]									= "Reload";
	stateWaitForTimeout[5]						= true;
	stateTransitionOnTimeout[5]				= "Reload_2";
	stateTimeoutValue[5]							= 0.2;
	
	stateName[6]									= "Reload_2";
	stateWaitForTimeout[6]						= true;
	stateTransitionOnTimeout[6]				= "Reload_3";
	stateSequence[6]								= "reload";
	stateTimeoutValue[6]							= 1.25;
	stateScript[6]									= "onUnload";
	stateSound[6]									= CRPG_Handgun_Unload_Sound;
	
	stateName[7]									= "Reload_3";
	stateSequence[7]								= "cock";
	stateWaitForTimeout[7]						= true;
	stateTransitionOnTimeout[7]				= "Ready";
	stateTimeoutValue[7]							= 0.15;
	stateScript[7]									= "onReload";
	stateSound[7]									= CRPG_Handgun_Reload_Sound;
	
	stateName[8]									= "PreAmmoCheck";
	stateTransitionOnTimeout[8]				= "AmmoCheck";
	stateTimeoutValue[8]							= 0.01;
	stateAllowImageChange[8]					= true;
	stateScript[8]									= "onAmmoCheck";
	
	stateName[9]									= "AmmoCheck";
	stateTransitionOnAmmo[9]					= "Ready";
	stateTransitionOnNoAmmo[9]					= "PreReload";
	stateAllowImageChange[9]					= true;
};

// Back Image
datablock ShapeBaseImageData(CRPG_Handgun_Back_Image)
{
	// Basic Item properties
	shapeFile = $CRPG::Path::Shapes @ "Handgun_Item.dts";
	emap = true;
	weaponBackpack = true;
	weaponImage = CRPG_Handgun_Image;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 7;
	offset = "0.45 -0.05 0.50";
	eyeOffset = "0 0 10";
	rotation = eulerToMatrix("-75 90 0");
	
	// Initial start up state
	stateName[0] = "Ready";
};

// Scripts
function CRPG_Handgun_Image::isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal)
{
	return %this.isRaycastHeadshot(%obj, %slot, %col, %pos, %normal);
}

function CRPG_Handgun_Image::onFire(%this, %obj, %slot)
{
	%obj.ammo[%this.ammo]--;
	%obj.fireTime[%this.ammo] = $sim::time;
	
	if(%obj.ammo[%this.ammo] < 1)
		%obj.setImageAmmo(%slot, false);
	
	return parent::onFire(%this, %obj, %slot);
}

function CRPG_Handgun_Image::onMount(%this, %obj, %slot)
{
	%obj.playThread(2, "armReadyLeft");
	%obj.hideNode("lhand");
	%obj.hideNode("lhook");
	%obj.hideNode("rhand");
	%obj.hideNode("rhook");
	
	if(%obj.ammo[%this.ammo] !$= "")
		if(%obj.ammo[%this.ammo] < 1)
			%obj.setImageAmmo(%slot, 0);
		else
			%obj.setImageAmmo(%slot, 1);
	else
		%obj.ammo[%this.ammo] = %this.ammoMagSize;
}

function CRPG_Handgun_Image::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
	
	if(isObject(%obj.client))
		applyCharacterPrefs(%obj.client);
	else
		applyDefaultCharacterPrefs(%obj);
}
