if(!$CRPG_Temp::WeaponsMade)
{
        eval("AddDamageType(\"CRPGSniper\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Sniper> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Sniper> %1', 0.25, 1);");
        eval("AddDamageType(\"CRPGSniperHeadshot\", '<bitmap:" @ $CRPG::Path::Images @ "CI/CI_Sniper><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', '%2 <bitmap:" @ $CRPG::Path::Images @ "CI/CI_Sniper><bitmap:" @ $CRPG::Path::Images @ "CI/CI_Headshot> %1', 0.25, 1);");
}

// Sounds
datablock AudioProfile(CRPG_Sniper_ArmSound)
{
        filename                = $CRPG::Path::Sounds @ "sniper_arm.wav";
        description        = AudioClose3d;
        preload                = true;
};

datablock AudioProfile(CRPG_Sniper_FireSound)
{
        filename                = $CRPG::Path::Sounds @ "sniper_fire.wav";
        description        = AudioClose3d;
        preload                = true;
};

datablock AudioProfile(CRPG_Sniper_HitSound)
{
        filename                = $CRPG::Path::Sounds @ "sniper_hit.wav";
        description        = AudioClose3d;
        preload                = true;
};

datablock AudioProfile(CRPG_Sniper_ReloadSound)
{
        filename                = $CRPG::Path::Sounds @ "sniper_reload.wav";
        description        = AudioClose3d;
        preload                = true;
};

// Dot Emitter
datablock ParticleData(CRPG_Sniper_Explosion_Dot_Particle)
{
        dragCoefficient                = 2;
        gravityCoefficient        = 0;
        inheritedVelFactor        = 0.2;
        constantAcceleration        = 0.0;
        lifetimeMS                                = 1240;
        lifetimeVarianceMS        = 1230;
        textureName                                = "base/data/particles/dot";
        spinSpeed                                = 0.0;
        spinRandomMin                        = 0.0;
        spinRandomMax                        = 0.0;
        colors[0]                                = "1 1 0.0 0.9";
        colors[1]                                = "1 1 1.0 0.0";
        sizes[0]                                        = 0.1;
        sizes[1]                                        = 0.2;
        useInvAlpha                                = false;
};

datablock ParticleEmitterData(CRPG_Sniper_Explosion_Dot_Emitter)
{
        lifeTimeMS                        = 100;
        ejectionPeriodMS        = 3;
        periodVarianceMS        = 0;
        ejectionVelocity        = 3;
        velocityVariance        = 3.0;
        ejectionOffset                = 1.0;
        thetaMin                                = 0;
        thetaMax                                = 180;
        phiReferenceVel        = 0;
        phiVariance                        = 360;
        overrideAdvance        = false;
        particles                        = "CRPG_Sniper_Explosion_Dot_Particle";
};

// Explosion
datablock ExplosionData(CRPG_Sniper_Explosion)
{
        soundProfile                = CRPG_Sniper_HitSound;
        
        lifeTimeMS                        = 150;
        
        particleEmitter        = CRPG_Explosion_Star_Emitter;
        particleDensity        = 5;
        particleRadius                = 0.2;
        
        emitter[0]                        = CRPG_Explosion_Star_Emitter;
        emitter[1]                        = CRPG_Sniper_Explosion_Dot_Emitter;
        
        faceViewer                        = true;
        explosionScale                = "1 1 1";
        
        shakeCamera                        = false;
        camShakeFreq                = "10.0 11.0 10.0";
        camShakeAmp                        = "1.0 1.0 1.0";
        camShakeDuration        = 0.5;
        camShakeRadius                = 10.0;
        
        lightStartRadius        = 1;
        lightEndRadius                = 0;
        lightStartColor        = "0.3 0.6 0.7";
        lightEndColor                = "0 0 0";

        impulseRadius                = 2;
        impulseForce                = 7500;
};

// Debris
datablock DebrisData(CRPG_Sniper_Debris)
{
        shapeFile                        = $CRPG::Path::Shapes @ "Sniper_Eject.dts";
        lifetime                                = 5.0;
        minSpinSpeed                = -400.0;
        maxSpinSpeed                = 200.0;
        elasticity                        = 0.5;
        friction                                = 0.2;
        numBounces                        = 0;
        staticOnMaxBounce = true;
        snapOnMaxBounce         = false;
        fade                                        = true;
        gravModifier                = 2;
};

// Projectile
datablock ProjectileData(CRPG_Sniper_Projectile)
{
        projectileShapeName        = $CRPG::Path::Shapes @ "Sniper_Eject.dts";
        
        directDamage                        = 25;
        directDamageType                = $DamageType::CRPGSniper;
        radiusDamageType                = $DamageType::CRPGSniper;
        
        brickExplosionRadius        = 0;
        brickExplosionImpact        = true;
        brickExplosionForce                = 10;
        brickExplosionMaxVolume = 1;
        brickExplosionMaxVolumeFloating = 2;
        
        impactImpulse                        = 1900;
        verticalImpulse                = 400;
        explosion                                = CRPG_Sniper_Explosion;
        
        muzzleVelocity                        = 1;
        velInheritFactor                = 1;
        
        armingDelay                                = 0;
        lifetime                                        = 1000;
        fadeDelay                                = 800;
        bounceElasticity                = 0.5;
        bounceFriction                        = 0.20;
        isBallistic                                = false;
        gravityMod                                = 0.1;
        
        hasLight                                        = false;
        lightRadius                                = 3.0;
        lightColor                                = "0 0 0.5";
};

// Item
datablock ItemData(CRPG_Sniper_Item)
{
        category = "Weapon";  // Mission editor category
        className = "Weapon"; // For inventory system
        
         // Basic Item Properties
        shapeFile = $CRPG::Path::Shapes @ "Sniper_Item.dts";
        rotate = false;
        mass = 1;
        density = 0.2;
        elasticity = 0.2;
        friction = 0.6;
        emap = true;
        
        //gui stuff
        uiName = "Sniper Rifle";
        iconName = $CRPG::Path::Images @ "itemIcons/Icon_Sniper";
        doColorShift = false;
        colorShiftColor = "0.4 0.2 0 1.000";
        
         // Dynamic properties defined by the scripts
        image = CRPG_Sniper_Image;
        canDrop = true;
};

// Image
datablock ShapeBaseImageData(CRPG_Sniper_Image)
{
        // Raycast Properties
        raycastWeaponRange                                = 1000;
        raycastWeaponOptimalRange                = -1;
        raycastWeaponTargets                                = $CRPG::ShootMasks;
        raycastWeaponPierceTargets                = 0;
        raycastDirectDamage                                = 25;
        raycastDirectDamageType                        = $DamageType::CRPGSniper;
        raycastCritDirectDamageType        = $DamageType::CRPGSniperHeadshot;
        raycastExplosionProjectile                = CRPG_Sniper_Projectile;
        raycastExplosionSound                        = CRPG_Sniper_HitSound;
        raycastExplosionPlayerSound        = CRPG_Sniper_HitSound;
        raycastExplosionBrickSound                = CRPG_Sniper_HitSound;
        raycastSpreadAmt                                        = 0.00000;        
        raycastSpreadCount                                = 1;
        raycastTracerProjectile                        = 0;
        raycastFromMuzzle                                        = true;
        
        // CRPG Properties
        ammo                        = "sniper";
        ammoMagName        = "Sniper";
        ammoMagSize        = 10;
        ammoUI                = "7.62x54R";
        backpack                = CRPG_Sniper_Back_Image;
        gunTier                = 5;
        kickBack                = 50;
        sensitive        = true;
        
        
        item = CRPG_Sniper_Item;
        
        // Basic Item properties
        shapeFile = $CRPG::Path::Shapes @ "Sniper.dts";
        emap = true;

        // Specify mount point & offset for 3rd person, and eye offset
        // for first person rendering.
        mountPoint = 0;
        offset = "0 0 0";
        eyeOffset = 0; //"0.7 1.2 -0.5";
        rotation = eulerToMatrix( "0 0 0" );

        // When firing from a point offset from the eye, muzzle correction
        // will adjust the muzzle vector to point to the eye LOS point.
        // Since this weapon doesn't actually fire from the muzzle point,
        // we need to turn this off.  
        correctMuzzleVector = true;

        // Add the WeaponImage namespace as a parent, WeaponImage namespace
        // provides some hooks into the inventory system.
        className = "WeaponImage";

        // Projectile
        item                                        = CRPG_Sniper_Item;
        projectile                        = CRPG_Sniper_Projectile;
        projectileType                = Projectile;
        
        casing                                        = CRPG_Sniper_Debris;
        shellExitDir                        = "1.0 -1.3 1.0";
        shellExitOffset                = "0 0 0";
        shellExitVariance                = 15.0;        
        shellVelocity                        = 7.0;
        
        //melee particles shoot from eye node for consistancy
        melee = false;
        //raise your arm up or not
        armReady = true;

        doColorShift = true;
        colorShiftColor = "0.4 0.2 0 1.000";

        //casing = " ";

        // Images have a state system which controls how the animations
        // are run, which sounds are played, script callbacks, etc. This
        // state system is downloaded to the client so that clients can
        // predict state changes and animate accordingly.  The following
        // system supports basic ready->fire->reload transitions as
        // well as a no-ammo->dryfire idle state.

        // Initial start up state
        stateName[0]                                                                = "Activate";
        stateTimeoutValue[0]                                                = 0.75;
        stateTransitionOnTimeout[0]                        = "PreAmmoCheck";
        stateSequence[0]                                                        = "cock";
        stateSound[0]                                                                = CRPG_Sniper_ArmSound;

        stateName[1]                                                                = "Ready";
        stateTransitionOnTriggerDown[1]                = "Fire";
        stateTransitionOnNoAmmo[1]                                = "AmmoCheck";
        stateAllowImageChange[1]                                = true;

        stateName[2]                                                                = "Fire";
        stateTransitionOnTimeout[2]                        = "Smoke";
        stateSequence[2]                                                        = "fire";
        stateTimeoutValue[2]                                                = 0.15;
        stateFire[2]                                                                = true;
        stateAllowImageChange[2]                                = false;
        stateScript[2]                                                                = "onFire";
        stateWaitForTimeout[2]                                        = true;
        stateEmitter[2]                                                        = CRPG_Flash_Emitter;
        stateEmitterTime[2]                                                = 0.05;
        stateEmitterNode[2]                                                = "muzzleNode";
        stateSound[2]                                                                = CRPG_Sniper_FireSound;
        
        stateName[3]                                                                = "Smoke";
        stateEmitter[3]                                                        = CRPG_Smoke_Emitter;
        stateEmitterTime[3]                                                = 0.85;
        stateEmitterNode[3]                                                = "muzzleNode";
        stateTimeoutValue[3]                                                = 0.85;
        stateEjectShell[3]                                                = true;
        stateTransitionOnTimeout[3]                        = "AmmoCheck";
        
        stateName[4]                                                                = "PreReload";
        stateWaitForTimeout[4]                                        = true;
        stateTransitionOnTimeout[4]                        = "Reload";
        stateTimeoutValue[4]                                                = 0.2;

        stateName[5]                                                                = "Reload";
        stateWaitForTimeout[5]                                        = true;
        stateTransitionOnTimeout[5]                        = "Reload_2";
        stateTimeoutValue[5]                                                = 0.2;
        
        stateName[6]                                                                = "Reload_2";
        stateWaitForTimeout[6]                                        = true;
        stateTransitionOnTimeout[6]                        = "Reload_3";
        stateSequence[6]                                                        = "reload";
        stateTimeoutValue[6]                                                = 1.6;
        stateSound[6]                                                                = CRPG_Sniper_ReloadSound;
        
        stateName[7]                                                                = "Reload_3";
        stateSequence[7]                                                        = "cock";
        stateWaitForTimeout[7]                                        = true;
        stateTransitionOnTimeout[7]                        = "Ready";
        stateTimeoutValue[7]                                                = 0.75;
        stateScript[7]                                                                = "onReload";
        stateSound[7]                                                                = CRPG_Sniper_ArmSound;
        
        stateName[8]                                                                = "PreAmmoCheck";
        stateTransitionOnTimeout[8]                        = "AmmoCheck";
        stateTimeoutValue[8]                                                = 0;
        stateAllowImageChange[8]                                = true;
        stateScript[8]                                                                = "onAmmoCheck";
        
        stateName[9]                                                                = "AmmoCheck";
        stateTransitionOnAmmo[9]                                = "Ready";
        stateTransitionOnNoAmmo[9]                                = "PreReload";
        stateAllowImageChange[9]                                = true;
};

// Back Image
datablock ShapeBaseImageData(CRPG_Sniper_Back_Image)
{
        // Basic Item properties
        shapeFile = $CRPG::Path::Shapes @ "Sniper_Item.dts";
        emap = true;
        weaponBackpack = true;
        weaponImage = CRPG_Sniper_Image;

        // Specify mount point & offset for 3rd person, and eye offset
        // for first person rendering.
        mountPoint = 7;
        offset = "0.10 -0.30 1.25";
        eyeOffset = "0 0 10";
        rotation = eulerToMatrix("60 -90 90");
        
        // Initial start up state
        stateName[0] = "Ready";
};

// Raycast Scripts
function CRPG_Sniper_Image::isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal)
{
        return %this.isRaycastHeadshot(%obj, %slot, %col, %pos, %normal);
}

function CRPG_Sniper_Image::onFire(%this, %obj, %slot)
{
        %obj.ammo[%this.ammo]--;
        %obj.fireTime[%this.ammo] = $sim::time;
        
        if(%obj.ammo[%this.ammo] < 1)
                %obj.setImageAmmo(%slot, false);
        
        return parent::onFire(%this, %obj, %slot);
}

function CRPG_Sniper_Image::onMount(%this, %obj, %slot)
{
        %obj.playThread(2, "armReadyLeft");
        %obj.hideNode("lhand");
        %obj.hideNode("lhook");
        %obj.hideNode("rhand");
        %obj.hideNode("rhook");
        
        if(%obj.ammo[%this.ammo] !$= "")
                if(%obj.ammo[%this.ammo] < 1)
                        %obj.setImageAmmo(%slot, 0);
                else
                        %obj.setImageAmmo(%slot, 1);
        else
                %obj.ammo[%this.ammo] = %this.ammoMagSize;
}

function CRPG_Sniper_Image::onUnMount(%this, %obj, %slot)
{
        %obj.playThread(2, "root");
        
        if(isObject(%obj.client))
                applyCharacterPrefs(%obj.client);
        else
                applyDefaultCharacterPrefs(%obj);
}
