function JobArmsDealerSO::getSuccessMessage(%so)
{
	return "\c6You have established connections with weapon manufacturers. You are now an \c3Arms Dealer\c6.";
}

if(!isObject(JobArmsDealerSO))
{
	new ScriptObject(JobArmsDealerSO)
	{
		class			= "JobSO";
		name			= "Arms Dealer";
		id				= "1" @ "04" @ "01";
		
		cleanRecord	= true;
		cost			= 2000;
		education	= 2;
		expMin		= 0;
		expTier		= 0;
		expTree		= "Store";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		runFactory	= false;
		runMonopoly	= false;
		sellArms		= true;
		sellFood		= false;
		sellVehicle	= false;
		
		outfit		= "OutfitArmsDealerSO";
		tools			= "";
	};
}

if(!isObject(OutfitArmsDealerSO))
{
	new ScriptObject(OutfitArmsDealerSO)
	{
		class = "OutfitSO";
		
		decal = "Hoodie";
		outfit = 10;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "knitHat";
		node[9] = "ShoulderPads";
		
		color[0] = "0.39 0.20 0.00 1.00";
		color[1] = "skin";
		color[2] = "skin";
		color[3] = "0.20 0.20 0.20 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.20 0.20 0.20 1.00";
		color[9] = "0.20 0.20 0.20 1.00";
	};
}