function JobLaborerSO::getError(%so, %client)
{
	return parent::getError(%so, %client);
}

function JobLaborerSO::getLaborBonus(%so, %client)
{
	%bonus = 1;
	
	if(isObject(%client.player))
	{
		initContainerRadiusSearch(%client.player.getPosition(), 16, $TypeMasks::PlayerObjectType);
		
		while(isObject(%col = containerSearchNext()))
		{
			%cp = %col.client.profile;
			
			if(isObject(%cp))
			{
				%cbonus = %cp.getJob().giveLaborBonus();
				
				if(%cbonus > %bonus)
				{
					%bonus = %cbonus;
				}
			}
		}
	}
	
	return %bonus;
}

function JobLaborerSO::getSuccessMessage(%so)
{
	return "\c6Because of your triumphs in you work, you are skilled enough to be known as a \c3Skilled Laborer\c6!";
}

function JobLaborerSO::onEXP(%so, %profile, %exp)
{
	if(JobForemanSO.isApplicable(%profile))
		JobForemanSO.setJobFor(%profile);
}

if(!isObject(JobLaborerSO))
{
	new ScriptObject(JobLaborerSO)
	{
		class			= "JobSO";
		name			= "Skilled Laborer";
		id				= "1" @ "03" @ "03";
		
		cleanRecord	= false;
		cost			= 0;
		education	= 2;
		expMin		= 250;
		expTier		= 1;
		expTree		= "Labor";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		outfit		= "OutfitLaborerSO";
		tools			= "CRPG_Lumberjack_Item" TAB "CRPG_Pickaxe_Item";
	};
}

if(!isObject(OutfitLaborerSO))
{
	new ScriptObject(OutfitLaborerSO)
	{
		class = "OutfitSO";
		
		decal = "worm_engineer";
		outfit = 9;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "LHand";
		node[3] = "genderrarm";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "copHat";
		
		color[0] = "0.20 0.20 0.20 1.00";
		color[1] = "0.20 0.20 0.20 1.00";
		color[2] = "0.20 0.20 0.20 1.00";
		color[3] = "0.20 0.20 0.20 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.20 0.20 0.20 1.00";
		
		outfitMale		= 1;
		nodeMale[0]		= "pack";
		colorMale[0]	= "0.20 0.20 0.20 1.00";
		
		outfitFem		= 1;
		nodeFem[0]		= "pack";
		colorFem[0]		= "0.90 0.50 0.59 1.00";
		
		customColor		= "pack";
	};
}
