function JobShopkeeperSO::getSuccessMessage(%so)
{
	return "\c6Your expertise in sales now allows you to micromanage weapons and food sales. You are now a \c3Shopkeeper\c6.";
}

if(!isObject(JobShopkeeperSO))
{
	new ScriptObject(JobShopkeeperSO)
	{
		class			= "JobSO";
		name			= "Shopkeeper";
		id				= "1" @ "04" @ "03";
		
		cleanRecord	= false;
		cost			= 5000;
		education	= 4;
		expMin		= 50;
		expTier		= 1;
		expTree		= "Store";
		paycheck		= 0;
		payday		= -1;
		police		= false;
		
		runFactory	= false;
		runMonopoly	= false;
		sellArms		= true;
		sellFood		= true;
		sellVehicle	= true;
		
		outfit		= "OutfitShopkeeperSO";
		tools			= "";
	};
}

if(!isObject(OutfitShopkeeperSO))
{
	new ScriptObject(OutfitShopkeeperSO)
	{
		class = "OutfitSO";
		
		decal = "worm_engineer";
		outfit = 10;
		
		node[0] = "gender";
		node[1] = "genderlarm";
		node[2] = "genderrarm";
		node[3] = "LHand";
		node[4] = "RHand";
		node[5] = "pants";
		node[6] = "LShoe";
		node[7] = "RShoe";
		node[8] = "knitHat";
		node[9] = "pack";
		
		color[0] = "1.00 1.00 1.00 1.00";
		color[1] = "1.00 1.00 1.00 1.00";
		color[2] = "1.00 1.00 1.00 1.00";
		color[3] = "0.20 0.20 0.20 1.00";
		color[4] = "0.20 0.20 0.20 1.00";
		color[5] = "0.20 0.20 0.20 1.00";
		color[6] = "0.20 0.20 0.20 1.00";
		color[7] = "0.20 0.20 0.20 1.00";
		color[8] = "0.20 0.20 0.20 1.00";
		color[9] = "0.20 0.20 0.20 1.00";
	};
}