function JobUnemployedSO::getSuccessMessage(%so)
{
	return "\c6You are now \c3collecting unemployment\c6.";
}

function JobUnemployedSO::onTick(%so, %client)
{
	%profile = %client.getProfile();
	%profile.workhours += CalendarSO.length;
	
	if(CalendarSO.getDOW() == 3 && mFloor(CalendarSO.time / 24) > mFloor((CalendarSO.time - CalendarSO.length) / 24))
	{
		//%pay = %so.paycheck;
		%pay = SystemSO.deductFromTreasury(%so.paycheck); //not sure if this works or not. 
								  //Ideally it should deduct all the money left in the treasury if its lower than the desired amount.
		%profile.exp[%so.expTree]++;
		
		%profile.workhours = 0;
		%interest = mFloor(%profile.debt * 0.1);
		
		if(%interest > 0)
		{
			%half = mFloor(%pay / 2);
			
			if(%interest > %half)
				%interest = %half;
			
			%final -= %interest;
			
			messageClient(%client, '', '\c6 - You recieved \c3$%1\c6 in unemployment, but \c0$%2\c6 was automatically taken out due to your debt\'s interest.', %pay, %interest);
			%profile.bank += %final;
		}
		else
		{
			messageClient(%client, '', '\c6 - You recieved \c3$%1\c6 in unemployment.', %pay);
			%profile.bank += %pay;
		}
		
		if(%profile.exp[%so.expTree] >= 10)
		{
			messageClient(%client, '', "\c6 - You have claimed as many paychecks as the government will allow.");
			JobVagabondSO.setJobFor(%client, false);
			messageClient(%client, '', "\c6 - " @ JobVagabondSO.getSuccessMessage());
		}
	}
}

if(!isObject(JobUnemployedSO))
{
	new ScriptObject(JobUnemployedSO)
	{
		class			= "JobSO";
		name			= "Unemployed";
		id				= "1" @ "01" @ "01";
		
		cleanRecord	= false;
		cost			= 0;
		education	= 0;
		expMin		= 0;
		expTier		= 0;
		expTree		= "Bum";
		paycheck		= 600;
		payday		= 3;
		police		= false;
		
		outfit		= "";
		tools			= "";
	};
}