datablock TSShapeConstructor(CRPG_Dog_DTS)
{
	baseShape  = $CRPG::Path::Shapes @ "Dog.dts";
	sequence0  = $CRPG::Path::Shapes @ "DOG_root.dsq root";

	sequence1  = $CRPG::Path::Shapes @ "DOG_run.dsq run";
	sequence2  = $CRPG::Path::Shapes @ "DOG_root.dsq walk";
	sequence3  = $CRPG::Path::Shapes @ "DOG_back.dsq back";
	sequence4  = $CRPG::Path::Shapes @ "DOG_side.dsq side";

	sequence5  = $CRPG::Path::Shapes @ "DOG_crouch.dsq crouch";
	sequence6  = $CRPG::Path::Shapes @ "DOG_crouchmove.dsq crouchRun";
	sequence7  = $CRPG::Path::Shapes @ "DOG_crouchmove.dsq crouchBack";
	sequence8  = $CRPG::Path::Shapes @ "DOG_crouchside.dsq crouchSide";

	sequence9  = $CRPG::Path::Shapes @ "DOG_root.dsq look";
	sequence10 = $CRPG::Path::Shapes @ "DOG_root.dsq headside";
	sequence11 = $CRPG::Path::Shapes @ "DOG_root.dsq headUp";

	sequence12 = $CRPG::Path::Shapes @ "DOG_jump.dsq jump";
	sequence13 = $CRPG::Path::Shapes @ "DOG_jump.dsq standjump";
	sequence14 = $CRPG::Path::Shapes @ "DOG_root.dsq fall";
	sequence15 = $CRPG::Path::Shapes @ "DOG_side.dsq land";

	sequence16 = $CRPG::Path::Shapes @ "DOG_bark.dsq armAttack";
	sequence17 = $CRPG::Path::Shapes @ "DOG_root.dsq armReadyLeft";
	sequence18 = $CRPG::Path::Shapes @ "DOG_root.dsq armReadyRight";
	sequence19 = $CRPG::Path::Shapes @ "DOG_root.dsq armReadyBoth";
	sequence20 = $CRPG::Path::Shapes @ "DOG_root.dsq spearready";  
	sequence21 = $CRPG::Path::Shapes @ "DOG_root.dsq spearThrow";

	sequence22 = $CRPG::Path::Shapes @ "DOG_bark.dsq talk";  

	sequence23 = $CRPG::Path::Shapes @ "DOG_death.dsq death1"; 
	
	sequence24 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftUp";
	sequence25 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftDown";
	sequence26 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftAway";
	sequence27 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftTo";
	sequence28 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftLeft";
	sequence29 = $CRPG::Path::Shapes @ "DOG_root.dsq shiftRight";
	sequence30 = $CRPG::Path::Shapes @ "DOG_root.dsq rotCW";
	sequence31 = $CRPG::Path::Shapes @ "DOG_root.dsq rotCCW";

	sequence32 = $CRPG::Path::Shapes @ "DOG_root.dsq undo";
	sequence33 = $CRPG::Path::Shapes @ "DOG_root.dsq plant";

	sequence34 = $CRPG::Path::Shapes @ "DOG_sit.dsq sit";

	sequence35 = $CRPG::Path::Shapes @ "DOG_root.dsq wrench";

   sequence36 = $CRPG::Path::Shapes @ "DOG_bark.dsq activate";
   sequence37 = $CRPG::Path::Shapes @ "DOG_barking.dsq activate2";

   sequence38 = $CRPG::Path::Shapes @ "DOG_root.dsq leftrecoil";
};  
  
datablock AudioProfile(CRPG_Dog_Pain_Sound)
{
	fileName = $CRPG::Path::Sounds @ "whimper.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(CRPG_Dog_Death_Sound)
{
	fileName = $CRPG::Path::Sounds @ "yelp.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(CRPG_Dog_Bark_Sound)
{
	fileName = $CRPG::Path::Sounds @ "bark.wav";
	description = AudioClose3d;
	preload = true;
};

datablock PlayerData(CRPG_Dog_Armor : PlayerStandardArmor)
{
	shapefile = $CRPG::Path::Shapes @ "Dog.dts";
	canJet = 0;

   cameramaxDist = 5;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 1;
		
	showEnergyBar = false;

	minJumpSpeed = 0;
	maxJumpSpeed = 200;
	
	rideable = false;
	canRide = false;
	paintable = true;
	
 	boundingBox			= vectorScale("1 1 2.5", 2.5);
 	crouchBoundingBox		= vectorScale("1 1 1.5", 2.5);
 	proneBoundingBox		= vectorScale("1 1 1.5", 2.5);

	useCustomPainEffects = true;
	PainSound			= CRPG_Dog_Pain_Sound;
	DeathSound			= CRPG_Dog_Death_Sound;

	lookUpLimit = 0.80;
	lookDownLimit = 0.80;

	jumpsound = "CRPG_Dog_Bark_Sound";

	uiName = "Dog";

};