datablock ParticleData(CRPG_TearGas_Particle)
{
	dragCoefficient		= 2;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0;
	constantAcceleration	= 2;
	lifetimeMS				= 40000;
	lifetimeVarianceMS	= 55;
	textureName				= "base/data/particles/cloud";
	spinSpeed				= 0.0;
	spinRandomMin			= -10.0;
	spinRandomMax			= 10.0;
	colors[0]				= "0.5 0.5 0.5 0.0";
	colors[1]				= "0.5 0.5 0.5 0.7";
	colors[2]				= "0.5 0.5 0.5 0.6";
	colors[3]				= "0.5 0.5 0.5 0.0";
	sizes[0]					= 10.15;
	sizes[1]					= 10.10;
	sizes[2]					= 10.15;
	sizes[3]					= 10.10;
	times[0]					= 0.1;
	times[1]					= 0.2;
	times[2]					= 0.9;
	times[3]					= 1.0;
	windCoefficient		= 0.0;
	useInvAlpha				= true;
};

datablock ParticleEmitterData(CRPG_TearGas_Emitter)
{
   ejectionPeriodMS	= 500;
   periodVarianceMS	= 0;
   ejectionVelocity	= 0.5;
   velocityVariance	= 0.0;
   ejectionOffset		= 0.0;
   thetaMin				= 0;
   thetaMax				= 20;
   phiReferenceVel	= 360;
   phiVariance			= 360;
   overrideAdvance	= false;
   particles			= "CRPG_TearGas_Particle";
   useEmitterColors	= true;
};

datablock ExplosionData(CRPG_TearGas_Explosion)
{
	//soundProfile		= CRPG_TearGas_HitSound;
	
	lifeTimeMS			= 150;
	
	particleEmitter	= CRPG_Explosion_Star_Emitter;
	particleDensity	= 5;
	particleRadius		= 0.2;
	
	emitter[0]			= CRPG_Explosion_Star_Emitter;
	
	faceViewer			= true;
	explosionScale		= "1 1 1";
	
	shakeCamera			= false;
	camShakeFreq		= "0.0 0.0 0.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 10.0;
	
	lightStartRadius	= 1;
	lightEndRadius		= 0;
	lightStartColor	= "0.3 0.6 0.7";
	lightEndColor		= "0 0 0";

	impulseRadius		= 2;
	impulseForce		= 7500;
};

datablock ProjectileData(CRPG_TearGas_Projectile)
{
	projectileShapeName = "base/data/shapes/hammer.dts";
	
	directDamage				= 75;
	directDamageType			= $DamageType::CRPGTearGas;
	radiusDamageType			= $DamageType::CRPGTearGas;
	
	brickExplosionRadius		= 0;
	brickExplosionImpact		= true;
	brickExplosionForce		= 10;
	brickExplosionMaxVolume = 1;
	brickExplosionMaxVolumeFloating = 2;
	
	impactImpulse			= 1900;
	verticalImpulse		= 400;
	explosion				= CRPG_TearGas_Explosion;
	
	muzzleVelocity			= 200;
	velInheritFactor		= 1;
	
	armingDelay				= 00;
	lifetime					= 9000;
	fadeDelay				= 8500;
	bounceElasticity		= 0.5;
	bounceFriction			= 0.20;
	isBallistic				= false;
	gravityMod				= 0.1;
	
	hasLight					= false;
	lightRadius				= 3.0;
	lightColor				= "0 0 0.5";
};
